<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Building Blocks</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070706;16541100">
	<META NAME="CHANGED" CONTENT="20070713;17204600">
	<STYLE>
	<!--
		P.style5 { font-size: 18pt; font-weight: bold }
	-->
	</STYLE>
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Building Blocks</H1>
<P>All files that are used in this tutorial, both the machines
demonstrated and the library of building blocks used to build them,
are available in <A HREF="buildingblocks.zip">buildingblocks.zip</A>.</P>
<P>Building Blocks are small Turing machines you can build or get
from a library of prebuilt machines. We have provided a few simple
blocks to get you started, these are: &quot;Move Left Until a&quot;,
&quot;Move Right Until a&quot;, &quot;Move Left Until Not a&quot;,
&quot;Move Right Until Not a&quot;, and similar blocks for b's and
blanks. The internals of the Building Block &quot;Move Left Until a&quot;
is shown below.</P>
<P ALIGN=CENTER><IMG SRC="leftuntila.jpg" NAME="Graphic1" ALIGN=BOTTOM WIDTH=486 HEIGHT=351 BORDER=0>
</P>
<P>Building blocks are meant to be used to assemble larger Turing
machines quickly and easily. Any Turing machine built in JFLAP can be
used as a building block by selecting the Building Block Tool (or
pressing b), clicking in the editor pane, and choosing the file to
use as a building block. Below is a Turing machine made out of
building blocks that changes all “a”s to “y”s, adds an “X”
character to the end of the input, and outputs after the “X” a
number of “I”s that correspond to the number of “a”s. Thus,
it serves to count the number of “a”s. For example f(ababb) =
ybybbXII and f(baabaa) = byybyyXIIII. The alphabet is {a, b}.</P>
<P ALIGN=CENTER><IMG SRC="countas.jpg" NAME="Graphic2" ALIGN=BOTTOM WIDTH=942 HEIGHT=414 BORDER=0></P>
<P ALIGN=LEFT>To add a building block to a file use the Building
Block Creator tool, highlighted in the image below. 
</P>
<P ALIGN=CENTER><IMG SRC="blockcreator.JPG" NAME="Graphic3" ALIGN=BOTTOM WIDTH=195 HEIGHT=33 BORDER=0></P>
<P ALIGN=LEFT>Click on an empty part of the editor. A file open
dialogue appears for you to choose what file to import as a block.
When you find the file and press open it will appear as a square with
the name of the file inside it. 
</P>
<P ALIGN=LEFT><IMG SRC="openfile.JPG" NAME="Graphic4" ALIGN=BOTTOM WIDTH=598 HEIGHT=431 BORDER=0><IMG SRC="rightblock.jpg" NAME="Graphic5" ALIGN=BOTTOM WIDTH=599 HEIGHT=436 BORDER=0></P>
<H2>Running Turing Machines With Building Blocks</H2>
<P><FONT SIZE=3>The default view of a Turing machine while running is
to view at the highest level, which only shows what block the
configurations are in. To see the states within the block, you can
select a configuration and then choose the Focus button. From that
point until Defocus is chosen JFLAP will follow the configuration
through the lowest level. displaying the state it is in inside the
block. The focused configuration is colored yellow in the
configuration pane. </FONT>
</P>
<P><FONT SIZE=3>To speed up stepping through the Turing machine when
you don't want this kind of detail we have provided a new type of
step called Step By Building Block. When chosen from the Input menu
it will process an entire building block every time the Step button
is clicked. Specifically, every time the step button is pressed JFLAP
will continue running each configuration until it exits the block.</FONT></P>
<P><FONT SIZE=3>Here the machine that counts a's from above is shown
in the middle of being tested. </FONT>
</P>
<P ALIGN=CENTER><IMG SRC="countarun.JPG" NAME="Graphic6" ALIGN=BOTTOM WIDTH=602 HEIGHT=436 BORDER=0></P>
<H2>Editing Building Blocks: 
</H2>
<P>&nbsp;Once a block, say &quot;smallBlock.jff&quot; has been added
to your Turing machine, it is stored inside that turing machine's
file which we'll call &quot;largeMachine.jff&quot;, so making changes
to the original file, “smallBlock.jff” will not change the
building block inside “largeMachine.jff”.&nbsp; To change the
block select the Attribute Editor by pressing the letter a, right
click on the block, and choose Edit Block.&nbsp; This opens a new tab
in which you can make changes to the block as with any other Turing
machine.&nbsp; When you are done making changes open the File menu
and choose Dismiss Tab.&nbsp; This will save the changes.&nbsp;
&nbsp;Multiple blocks from the same file may be added to a turing
machine, but changes to one block will not affect the other blocks.
When editing blocks you should be careful to update the name of the
block to reflect the new changes as it can be easy to forget what you
did making debugging difficult.</P>
<H2><A NAME="bbtransitions"></A>Mixing Blocks and States:</H2>
<P><FONT SIZE=3>Building Blocks can be treated like States in that
transitions can be added to them just like States.&nbsp; However,
there is also a Block Transition Creator tool that can be used
instead, highlighted in the image below. &nbsp;</FONT></P>
<P ALIGN=CENTER><IMG SRC="blocktransition.JPG" NAME="Graphic7" ALIGN=BOTTOM WIDTH=197 HEIGHT=36 BORDER=0></P>
<P><FONT SIZE=3>This type of transition allows input of one letter.&nbsp;
When running the Turing machine, if it reaches the final state of the
first block, and the head is pointing to the same letter as in the
transition, it will move into the initial state of the second block.&nbsp;
The tape head will not move, and no letter will be written to the
tape.</FONT></P>
<P><FONT SIZE=3>As you can see from the image below, any kind of
transition can be added between any combination of blocks and states.</FONT></P>
<P ALIGN=CENTER><IMG SRC="image004.jpg" NAME="Graphic8" ALIGN=BOTTOM WIDTH=576 HEIGHT=255 BORDER=0></P>
<H2>New Transition Syntax</H2>
<P><B>Not X:</B></P>
<P>This allows transitions that read in any letter other than the
ones specified, instead of having to create one for each letter. &nbsp;For
instance if you wish to transition from state one to state two after
reading all letters except b, writing the letter c always, you could
use the syntax read !b, write c, S. As shown in the machine below.</P>
<P>&nbsp;</P>
<P ALIGN=CENTER><!--[if gte vml 1]><v:shape
 id="_x0000_i1028" type="#_x0000_t75" style='width:226.5pt;height:195.75pt'>
 <v:imagedata src="Help_files/image007.png" o:title="not"/>
</v:shape><![endif]--><!--[if !vml]--><IMG SRC="image008.jpg" NAME="Graphic9" ALIGN=BOTTOM WIDTH=302 HEIGHT=261 BORDER=0></P>
<P><B>Variable Assignment :</B></P>
<P>To use this feature create a regular transition between two states
or blocks, we'll call them A and B, and in the first field type the
letters you wish to assign to the variable.&nbsp; For example
“a,b,c}w” would mean that when the Turing machine got state A if
the head was on either a, b, or c the letter at the head would from
then on be synonymous with w.&nbsp; This means that later transitions
that say read w or write w actually mean read the letter that was at
the head or write that letter.&nbsp;&nbsp; An example machine is
shown below.&nbsp; The first transition says to store the letter at
the head as w and move the head right.&nbsp; The next transition says
if the new letter at the head is the same as w, write b and move
right again. The input is only accepted when two of the same letters
are in a row, aa, bb, or cc.&nbsp; The output if used as a transducer
is ab, bb, or cb.</P>
<P>Below is a Turing machine that duplicates the input string
separated by 0 over the alphabet {a, b}. Input of aababacc for
example gives aababacc0aababacc. 
</P>
<P ALIGN=CENTER><IMG SRC="duplicatestring.jpg" NAME="Graphic10" ALIGN=BOTTOM WIDTH=784 HEIGHT=441 BORDER=0>
</P>
<P ALIGN=LEFT>&nbsp;</P>
<P ALIGN=LEFT>When the machine starts it moves right until it finds a
blank, rights a 0, moves left until it finds a blank, moves one right
so that the head is on the first letter of the input string. Out of
this block there are two transitions; we'll focus on the one that
says a,b,c}w, w, S. This states that if the letter pointed to by the
head is a, b, or c that letter will be assigned to the variable w. We
then write w to the tape, which is the same thing that was just read.
In the next step we write a blank over what was just written, move
right until the next blank, and write w over it. We then move left
until the first blank and rewrite w over the blank. We are now back
in the fifth block from start, labeled R and ready to continue
duplicating the string or branch to the final state if everything has
been duplicated. 
</P>
<P CLASS="style5">Building Block Tools</P>
<P><FONT SIZE=3><B>Duplicate Block:</B> </FONT>
</P>
<P><FONT SIZE=3>If you need a copy of a block, right click on it and
select Duplicate Block. By default it will be named Copy of x, where
x is the name of the original block, and will appear directly under
the original. As with blocks loaded from the same files, changes to
one will not affect the other as they are not linked. <BR>This tool
is especially useful for situations where you have loaded multiple
blocks from the same file before discovering an error in the original
file. Now all you have to do is edit one block to fix it, erase all
the other blocks that were loaded from the file, and then replace
them by duplicating the fixed block. </FONT>
</P>
<P ALIGN=CENTER><IMG SRC="duplicate.JPG" NAME="Graphic11" ALIGN=BOTTOM WIDTH=597 HEIGHT=435 BORDER=0></P>
<P><FONT SIZE=3><B>Replace Character Within Block</B> </FONT>
</P>
<P><FONT SIZE=3>To replace all occurrences of a letter within a
block, right click on the block and choose Replace Symbol. Type the
character you want to replace and press enter, then type the
character you want to take it's place and press enter. The character
will be replaced in all transitions inside the block including all
transitions inside all sub-blocks. The picture above shows a file
that changes all A's in the input string to X's. Here is the inside
of the block rightUntilA.</FONT></P>
<P ALIGN=CENTER><IMG SRC="rightuntilA.JPG" NAME="Graphic12" ALIGN=BOTTOM WIDTH=600 HEIGHT=432 BORDER=0>
</P>
<P ALIGN=LEFT><FONT SIZE=3>To change the file to one that changes all
B's in the input string to X's instead, use Replace Character Within
Block. Type A, press Enter, type B, press Enter. Now the inside of
rightUntilA looks like this.</FONT></P>
<P ALIGN=CENTER><IMG SRC="rightUntilB.JPG" NAME="Graphic13" ALIGN=BOTTOM WIDTH=600 HEIGHT=434 BORDER=0>
</P>
<P ALIGN=LEFT><FONT SIZE=3>Be careful to change the name of the block
to rightUntilB to avoid confusion. </FONT>
</P>
<P ALIGN=LEFT><FONT SIZE=3><B>This concludes our brief tutorial on
building blocks. Thanks for reading!</B>&nbsp;</FONT></P>
</BODY>
</HTML>
